/***********************************************************************
 * fontTiny.h - 8x8 fonts defined for ascii characters with codes > 32;
 *         - used in Wise Clock 3;
 * Copyright by FlorinC;
 *   Copyrighted and distributed under the terms of the Berkeley license
 *   (copy freely, but include this notice of original author.)
 ***********************************************************************
 */


// define all ascii characters starting with 32 (blank);
// 4 column-wide font;
//
unsigned char PROGMEM tinyFont[95][8] = {
  {
    0x00,    // ____   blank (ascii 32)
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00     // ____
  },
  {
    0x00,    // ____  !
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x00,    // ____
    0x04,    // _X__
    0x00,    // ____
  },
  {
    0x00,    // ____  "
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
  },
  {
    0x00,    // ____  #
    0x00,    // ____
    0x0C,    // X_X_
    0x0F,    // XXXX
    0x0C,    // X_X_
    0x0F,    // XXXX
    0x0C,    // X_X_
    0x00,    // ____
  },
  {
    0x00,    // ____  $
    0x04,    // _X__
    0x06,    // _XX_
    0x0C,    // XX__
    0x06,    // _XX_
    0x06,    // _XX_
    0x0C,    // XX__
    0x04,    // _X__
  },
  {
    0x00,    // ________  %
    0x00,    // ________
    0x32,    // __XX__X_
    0x34,    // __XX_X__
    0x08,    // ____X___
    0x16,    // ___X_XX_
    0x26,    // __X__XX_
    0x00,    // ________
  },
  {
    0x00,    // ________  &
    0x00,    // ________
    0x18,    // ___XX___
    0x24,    // __X__X__
    0x18,    // ___XX___
    0x26,    // __X__XX_
    0x1E,    // ___XXXX_
    0x00,    // ________
  },
  {
    0x00,    // ________  '
    0x18,    // ___XX___
    0x18,    // ___XX___
    0x10,    // ___X____
    0x00,    // ________
    0x00,    // ________
    0x00,    // ________
    0x00,    // ________
  },
  {
    0x00,    // ________  (
    0x08,    // ____X___
    0x10,    // ___X____
    0x10,    // ___X____
    0x10,    // ___X____
    0x10,    // ___X____
    0x08,    // ____X___
    0x00,    // ________
  },
  {
    0x00,    // ________  )
    0x10,    // ___X____
    0x08,    // ____X___
    0x08,    // ____X___
    0x08,    // ____X___
    0x08,    // ____X___
    0x10,    // ___X____
    0x00,    // ________
  },
  {
    0x00,    // ________  *
    0x00,    // ________
    0x08,    // ____X___
    0x2A,    // __X_X_X_
    0x08,    // ____X___
    0x2A,    // __X_X_X_
    0x08,    // ____X___
    0x00,    // ________
  },
  {
    0x00,    // ________  +
    0x00,    // ________
    0x08,    // ____X___
    0x08,    // ____X___
    0x3E,    // __XXXXX_
    0x08,    // ____X___
    0x08,    // ____X___
    0x00,    // ________
  },
  {
    0x00,    // ________  ,
    0x00,    // ________
    0x00,    // ________
    0x00,    // ________
    0x00,    // ________
    0x18,    // ___XX___
    0x08,    // ____X___
    0x10,    // ___X____
  },
  {
    0x00,    // ________  -
    0x00,    // ________
    0x00,    // ________
    0x00,    // ________
    0x3E,    // __XXXXX_
    0x00,    // ________
    0x00,    // ________
    0x00,    // ________
  },
  {
    0x00,    // ____  .
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ________  /
    0x00,    // ________
    0x02,    // ______X_
    0x04,    // _____X__
    0x08,    // ____X___
    0x10,    // ___X____
    0x20,    // __X_____
    0x00,    // ________
  },
  {
    0x00,    // ____  0
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____  1
    0x02,    // __X_
    0x06,    // _XX_
    0x02,    // __X_
    0x02,    // __X_
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  2
    0x06,    // _XX_
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  3
    0x07,    // _XXX
    0x01,    // ___X
    0x06,    // _XX_
    0x01,    // ___X
    0x06,    // _XX_
    0x00,    // ____
  },
  {
    0x00,    // ____  4
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x01,    // ___X
    0x01,    // ___X
    0x00,    // ____
  },
  {
    0x00,    // ____  5
    0x07,    // _XXX
    0x04,    // _X__
    0x07,    // _XXX
    0x01,    // ___X
    0x06,    // _XX_
    0x00,    // ____
  },
  {
    0x00,    // ____  6
    0x03,    // __XX
    0x04,    // _X__
    0x07,    // _XXX
    0x05,    // _X_X
    0x02,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  7
    0x07,    // _XXX
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x04,    // _X__
    0x00,    // ____
  },
  {
    0x00,    // ____  8
    0x07,    // _XXX
    0x05,    // _X_X
    0x07,    // _XXX
    0x05,    // _X_X
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  9
    0x07,    // _XXX
    0x05,    // _X_X
    0x07,    // _XXX
    0x01,    // ___X
    0x06,    // _XX_
    0x00,    // ____
  },
  {
    0x00,    // ____  :
    0x00,    // ____
    0x02,    // __X_
    0x00,    // ____
    0x02,    // __X_
    0x00,    // ____
    0x00,    // ____
  },
  {
    0x00,    // ____  ;
    0x00,    // ____
    0x06,    // _XX_
    0x06,    // _XX_
    0x00,    // ____
    0x06,    // _XX_
    0x02,    // __X_
    0x04,    // _X__
  },
  {
    0x00,    // ____  <
    0x00,    // ____
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x02,    // __X_
    0x01,    // ___X
    0x00,    // ____
  },
  {
    0x00,    // ____  =
    0x00,    // ____
    0x00,    // ____
    0x07,    // _XXX
    0x00,    // ____
    0x07,    // _XXX
    0x00,    // ____
    0x00,    // ____
  },
  {
    0x00,    // ____  >
    0x00,    // ____
    0x04,    // _X__
    0x02,    // __X_
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x00,    // ____
  },
  {
    0x00,    // ____  ?
    0x06,    // _XX_
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x00,    // ____
    0x04,    // _X__
    0x00,    // ____
  },
  {
    0x00,    // ____  @
    0x06,    // _XX_
    0x09,    // X__X
    0x0B,    // X_XX
    0x0B,    // X_XX
    0x08,    // X___
    0x06,    // _XX_
    0x00,    // ____
  },
  {
    0x00,    // ____   A
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x00     // ____
  },
  {
    0x00,    // ____   B
    0x06,    // _XX_
    0x05,    // _X_X
    0x06,    // _XX_
    0x05,    // _X_X
    0x05,    // _X_X
    0x06,    // _XX_
    0x00     // ____
  },
  {
    0x00,    // ____   C
    0x02,    // __X_
    0x05,    // _X_X
    0x04,    // _X__
    0x04,    // _X__
    0x05,    // _X_X
    0x02,    // __X_
    0x00     // ____
  },
  {
    0x00,    // ____   D
    0x06,    // _XX_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x06,    // _XX_
    0x00     // ____
  },
  {
    0x00,    // ____   E
    0x07,    // _XXX
    0x04,    // _X__
    0x06,    // _XX_
    0x04,    // _X__
    0x04,    // _X__
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   F
    0x07,    // _XXX
    0x04,    // _X__
    0x06,    // _XX_
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x00     // ____
  },
  {
    0x00,    // ____  G
    0x03,    // __XX
    0x04,    // _X__
    0x04,    // _X__
    0x05,    // _X_X
    0x05,    // _X_X
    0x03,    // __XX
    0x00     // ____
  },
  {
    0x00,    // ____  H
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x00     // ____
  },
  {
    0x00,    // ____  I
    0x07,    // _XXX
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____  J
    0x07,    // _XXX
    0x01,    // ___X
    0x01,    // ___X
    0x01,    // ___X
    0x05,    // _X_X
    0x02,    // __X_
    0x00     // ____
  },
  {
    0x00,    // ____  K
    0x05,    // _X_X
    0x05,    // _X_X
    0x06,    // _XX_
    0x06,    // _XX_
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
  },
  {
    0x00,    // ____  L
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____   M
    0x05,    // _X_X 
    0x07,    // _XXX 
    0x07,    // _XXX 
    0x05,    // _X_X 
    0x05,    // _X_X 
    0x05,    // _X_X 
    0x00     // ____ 
  },
  {
    0x00,    // ____  N
    0x05,    // _X_X
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
  },
  {
    0x00,    // ____  O
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____  P
    0x06,    // _XX_
    0x05,    // _X_X
    0x06,    // _XX_
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x00,    // ____
  },
  {
    0x00,    // ____  Q
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x03,    // __XX
    0x00,    // ____
  },
  {
    0x00,    // ____  R
    0x06,    // _XX_
    0x05,    // _X_X
    0x06,    // _XX_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
  },
  {
    0x00,    // ____  S
    0x03,    // __XX
    0x04,    // _X__
    0x02,    // __X_
    0x01,    // ___X
    0x05,    // _X_X
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____  T
    0x07,    // _XXX
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____  U
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  V
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____  W
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____ X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
  },
  {
    0x00,    // ____  Y
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____ Z
    0x07,    // _XXX
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x04,    // _X__
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  :
    0x06,    // _XX_
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x06,    // _XX_
    0x00,    // ____
  },
  {
    0x00,    // ____  \
    0x00,    // ____
    0x04,    // _X__
    0x04,    // _X__
    0x02,    // __X_
    0x01,    // ___X
    0x01,    // ___X
    0x00,    // ____
  },
  {
    0x00,    // ____  ]
    0x03,    // _XX_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x03,    // _XX_
    0x00,    // ____
  },
  {
    0x00,    // ____  ^
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
  },
  {
    0x00,    // ____  _
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x07,    // _XXX
    0x00,    // ____
  },
  {
    0x00,    // ____  `
    0x02,    // __X_
    0x01,    // ___X
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
    0x00,    // ____
  },
  {
    0x00,    // ____   a
    0x00,    // ____
    0x06,    // _XX_
    0x01,    // ___X
    0x07,    // _XXX
    0x05,    // _X_X
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   b
    0x04,    // _X__
    0x04,    // _X__
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   c
    0x00,    // ____
    0x03,    // __XX
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x03,    // __XX
    0x00     // ____
  },
  {
    0x00,    // ____   d
    0x01,    // ___X
    0x01,    // ___X
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   e
    0x00,    // ____
    0x02,    // __X_
    0x04,    // _X_X
    0x07,    // _XXX
    0x04,    // _X__
    0x03,    // __XX
    0x00     // ____
  },
  {
    0x00,    // ____   f
    0x03,    // __XX
    0x02,    // __X_
    0x02,    // __X_
    0x07,    // _XXX
    0x02,    // __X_
    0x02,    // __X_
    0x00,    // ____
  },
  {
    0x00,    // ____   g
    0x00,    // ____
    0x03,    // __XX
    0x05,    // _X_X
    0x07,    // _XXX
    0x01,    // ___X
    0x01,    // ___X
    0x06     // _XX_
  },
  {
    0x00,    // ____   h
    0x04,    // _X__
    0x04,    // _X__
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x00     // ____
  },
  {
    0x00,    // ____   i
    0x02,    // __X_
    0x00,    // ____
    0x06,    // _XX_
    0x02,    // __X_
    0x02,    // __X_
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   j
    0x01,    // ___X
    0x00,    // ____
    0x07,    // _XXX
    0x01,    // ___X
    0x01,    // ___X
    0x05,    // _X_X
    0x02     // __X_
  },
  {
    0x00,    // ____   k
    0x00,    // ____
    0x04,    // _X__
    0x05,    // _X_X
    0x06,    // _XX_
    0x05,    // _X_X
    0x05,    // _X_X
    0x00     // ____
  },
  {
    0x00,    // ____   l
    0x06,    // _XX_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____  m
    0x00,    // ____
    0x06,    // _XX_
    0x07,    // _XXX
    0x07,    // _XXX
    0x05,    // _X_X
    0x05,    // _X_X
    0x00,    // ____
  },
  {
    0x00,    // ____   n
    0x00,    // ____
    0x06,    // _XX_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x00     // ____
  },
  {
    0x00,    // ____   o
    0x00,    // ____
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x00     // ____
  },
  {
    0x00,    // ____   p
    0x00,    // ____
    0x06,    // _XX_
    0x05,    // _X_X
    0x06,    // _XX_
    0x04,    // _X__
    0x04,    // _X__
    0x04     // _X__
  },
  {
    0x00,    // ____   q
    0x00,    // ____
    0x03,    // __XX
    0x05,    // _X_X
    0x07,    // _XXX
    0x01,    // ___X
    0x01,    // ___X
    0x01     // ___X
  },
  {
    0x00,    // ____   r
    0x00,    // ____
    0x03,    // __XX
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x04,    // _X__
    0x00     // ____
  },
  {
    0x00,    // ____   s
    0x00,    // ____
    0x03,    // __XX
    0x04,    // _X__
    0x02,    // __X_
    0x01,    // ___X
    0x06,    // _XX_
    0x00     // ____
  },
  {
    0x00,    // ____   t
    0x02,    // __X_
    0x07,    // _XXX
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x01,    // ___X
    0x00     // ____
  },
  {
    0x00,    // ____   u
    0x00,    // ____
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x03,    // __XX
    0x00     // ____
  },
  {
    0x00,    // ____   v
    0x00,    // ____
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x00     // ____
  },
  {
    0x00,    // ____   w
    0x00,    // ____
    0x05,    // _X_X
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   x
    0x00,    // ____
    0x05,    // _X_X
    0x05,    // _X_X
    0x02,    // __X_
    0x05,    // _X_X
    0x05,    // _X_X
    0x00     // ____
  },
  {
    0x00,    // ____   y
    0x00,    // ____
    0x05,    // _X_X
    0x05,    // _X_X
    0x07,    // _XXX
    0x01,    // ___X
    0x01,    // ___X
    0x06     // _XX_
  },
  {
    0x00,    // ____   z
    0x00,    // ____
    0x07,    // _XXX
    0x01,    // ___X
    0x02,    // __X_
    0x04,    // _X__
    0x07,    // _XXX
    0x00     // ____
  },
  {
    0x00,    // ____   {
    0x01,    // ___X
    0x02,    // __X_
    0x02,    // __X_
    0x04,    // _X__
    0x02,    // __X_
    0x02,    // __X_
    0x01     // ___X
  },
  {
    0x00,    // ____   |
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x02,    // __X_
    0x00     // ____
  },
  {
    0x00,    // ____   }
    0x04,    // _X__
    0x02,    // __X_
    0x02,    // __X_
    0x01,    // ___X
    0x02,    // __X_
    0x02,    // __X_
    0x04     // _X__
  },
  {
    0x00,    // ____   ~ (ascii 126)
    0x00,    // ____
    0x04,    // _X__
    0x0B,    // X_XX
    0x01,    // ___X
    0x00,    // ____
    0x00,    // ____
    0x00     // ____
  },
};
